import 'package:flutter/material.dart';

class InterestZone extends CustomPainter {
  final double heightInterestFactor;
  final double widthInterestFactor;
  InterestZone(
      {required this.heightInterestFactor, required this.widthInterestFactor});

  @override
  void paint(Canvas canvas, Size size) {
    canvas.saveLayer(Rect.largest, Paint());
    final rect = Rect.fromLTWH(0, 0, size.width, size.height);

    final paint = Paint()
      ..color = Colors.black.withOpacity(0.5) // Opacidade de 70%
      ..style = PaintingStyle.fill;
    // Desenha o quadrado preto
    canvas.drawRect(rect, paint);
    final holeSize = Size(
        size.width * widthInterestFactor, size.height * heightInterestFactor);
    final holeRect = Rect.fromCenter(
      center: size.center(Offset.zero),
      width: holeSize.width,
      height: holeSize.height,
    );

    final RRect roundedRect =
        RRect.fromRectAndRadius(holeRect, const Radius.circular(20));

    final holePaint = Paint()
      ..blendMode = BlendMode.clear
      ..color = Colors.transparent
      ..strokeWidth = 2;

    final borderpaint = Paint()
      ..color = Colors.blue
      ..style = PaintingStyle.stroke
      ..strokeWidth = 2;

    // Desenha o buraco transparente no centro
    canvas.drawRRect(roundedRect, holePaint);
    canvas.drawRRect(roundedRect, borderpaint);
    canvas.restore();
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return false;
  }
}
